# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
program Pick2cmplx2
  ! Convert a binary image to complex scatter pairs Jesse Lomask 6/19/04

  use sep
 ! use lint2
 ! use warp_mod
 ! use sorting_mod
 ! use paint_mod3d

  implicit none

  integer ::nt, nx, ny, non_zero_mask,istatus,bnd_index,delx,delt,count
  integer ::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer ::it_new,ix_new
  real::o1,o2,o3,d1,d2,d3

  real, pointer, dimension(:,:) ::data,data2
  complex, allocatable, dimension(:) ::cmplx_out,cmplx_out2
!!$ real, dimension(:,:,:) ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init("/scr3/jeff/sep125/jesse1/Src/Pick2cmplx2.f90")

!!$ ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);

  call from_history("o1",o1); call from_history("o2",o2)
  call from_history("d1",d1); call from_history("d2",d2)


  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx),data2(nt,nx),cmplx_out(nt*nx))


  ! READ INPUT DATA
  call sep_read(data)
  data2=0.

  iq=0
  outer: do ix=1,nx
     do it=1,nt
    ! if (data(it,ix)>0..and.sum(data2(max(1,it-1):min(nt,it+1),max(1,ix-1):min(nx,ix+1)))<0.0001) then ! found an end point
     if (data(it,ix)>0.) then ! found an end point
           iq=iq+1
           cmplx_out(iq)=cmplx(ix*d2+o2,it*d1+o1)
           data2(it,ix)=1.
        end if


     end do
  end do outer
  write(0,*) 'iq',iq

  allocate(cmplx_out2(iq))
  cmplx_out2(1:iq)=cmplx_out

  call to_history("n1",iq) ;call to_history("n2",1)
  call to_history("n3",1)
  call to_history("d1",1.) ;call to_history("d2",1.);call to_history("d3",1.)
  call to_history("o1",0.) ;call to_history("o2",0.);call to_history("o3",0.)

  call to_history("esize",8)
  call sep_write(cmplx_out2)
  deallocate(cmplx_out2,cmplx_out)






end program Pick2cmplx2
