program Create_picks  !
  !
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten,horizons,horizon_inc,dash,horizon_end
  integer                                ::horizon_strt,slice,thick,del_i2,counter
  real,    dimension (:,:),   allocatable ::image2d
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: mask_out,pick_out,mask_out2,mask_out3
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,xrand,first_point,second_point,totalx,totaly,x_squared,y_squared
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1)
  call from_param("horizons",horizons,0)
  call from_param("horizon_inc",horizon_inc,30)
  call from_param("horizon_strt",horizon_strt,1)
  call from_param("horizon_end",horizon_end,n1-1)
  call from_param("slice",slice,0)
  call from_param("dash",dash,0)
  call from_param("thick",thick,0)
  write(0,*) n1,n2,n3,ref_2,ref_3,horizon_inc
  write(0,*)'slice',slice

  subsam=1
  allocate (pick_out(n1,n2,n3),mask_out(n1,n2,n3),mask_out2(n1,n2,n3),mask_out3(n1,n2,n3))                              


  write(0,*) 'n1/n2/n3',n1,n2,n3
  ! call sreed("dipx", dipx,4*n1*n2*n3)
  ! call sreed("dipy", dipy,4*n1*n2*n3)
  ! call sreed("in", data_in,4*n1*n2*n3)
  ! call sreed("aux", time_cube,4*n1*n2*n3)


  pick_out=0.
  mask_out=1.

  pick_out(64,50,39)=0.
  pick_out(64,59,7) =-14.
  pick_out(64,16,7) =27.
  pick_out(64,72,7) =-13.
  pick_out(64,89,7) =-19.
  pick_out(64,99,7) =-3.
  pick_out(64,9,22) =29.
  pick_out(64,56,22)=-13.
  pick_out(64,83,22)=-16.
  pick_out(64,99,22)=0.
  pick_out(64,10,42)=30.
  pick_out(64,49,42)=2.
  pick_out(64,69,42)=-16.
  pick_out(64,90,42)=-20.
  pick_out(64,98,42)=-6.
 pick_out(64,69,22)=-14.
 pick_out(64,81,22)=-17.
 pick_out(64,70,34)=-16.
 pick_out(64,70,25)=-16.
 pick_out(64,71,39)=-17.
 pick_out(64,64,39)=-14.
 pick_out(64,92,39)=-20.

  mask_out(64,50,39)=0.
  mask_out(64,59,7) =0.
  mask_out(64,16,7) =0.
  mask_out(64,72,7) =0.
  mask_out(64,89,7) =0.
  mask_out(64,99,7) =0.
  mask_out(64,9,22) =0.
  mask_out(64,56,22)=0.
  mask_out(64,83,22)=0.
  mask_out(64,99,22)=0.
  mask_out(64,10,42)=0.
  mask_out(64,49,42)=0.
  mask_out(64,69,42)=0.
  mask_out(64,90,42)=0.
  mask_out(64,98,42)=0.
 mask_out(64,69,22)=0.
 mask_out(64,81,22)=0.
 mask_out(64,70,34)=0.
 mask_out(64,70,25)=0.
 mask_out(64,71,39)=0.
 mask_out(64,64,39)=0.
 mask_out(64,92,39)=0.



 mask_out2(1:,1:,1:)=1.
 mask_out2(64,1:,1:)=0.


 mask_out3(1:,1:,1:)=1.
mask_out3(1:22,1:,1:)=0.
 mask_out3(64,1:,1:)=0.




!!$  data_out=0.
!!$  image2d=0.
!!$
!!$  totalx=0.
!!$  totaly=0.
!!$  x_squared=0.
!!$  y_squared=0.
!!$  counter=0
!!$  do i1=1,20
!!$     do i2=1,n2
!!$        inner: do i3=1,n3
!!$           !      if (dipx(i1,i2,i3)==0.) then
!!$           !      else
!!$           counter=counter+1
!!$           totalx=totalx+(dipx(i1,i2,i3))
!!$           totaly=totaly+(dipy(i1,i2,i3))
!!$           x_squared=x_squared+dipx(i1,i2,i3)*dipx(i1,i2,i3)
!!$           y_squared=y_squared+dipy(i1,i2,i3)*dipy(i1,i2,i3)
!!$
!!$           !     end if
!!$        end do inner
!!$     end do
!!$  end do
!!$  write(0,*) 'totalx',totalx,'avr x',totalx/counter
!!$  write(0,*) 'totaly',totaly,'avr y',totaly/counter
!!$  write(0,*) 'counter',counter
!!$  write(0,*) 'variance x',(x_squared-(totalx*totalx/counter))/counter
!!$  write(0,*) 'variance y',(y_squared-(totaly*totaly/counter))/counter
!!$
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  !call to_history("d1",1)
  call sep_write (pick_out) 
!!$

  call to_history("n1",n1,"mask_out"); call to_history("n2",n2,"mask_out")
  call to_history("n3",n3,"mask_out")
  call to_history("d1",1.0,"mask_out"); call to_history("d2",1.0,"mask_out")
  call to_history("d3",1.0,"mask_out")
  call to_history("o1",0.,"mask_out"); call to_history("o2",0.,"mask_out")
  call to_history("o3",0.,"mask_out")
  call to_history("esize",4,"mask_out")
  call sep_write(mask_out,"mask_out")	


  call to_history("n1",n1,"mask_out2"); call to_history("n2",n2,"mask_out2")
  call to_history("n3",n3,"mask_out2")
  call to_history("d1",1.0,"mask_out2"); call to_history("d2",1.0,"mask_out2")
  call to_history("d3",1.0,"mask_out2")
  call to_history("o1",0.,"mask_out2"); call to_history("o2",0.,"mask_out2")
  call to_history("o3",0.,"mask_out2")
  call to_history("esize",4,"mask_out2")
  call sep_write(mask_out2,"mask_out2")	


  call to_history("n1",n1,"mask_out3"); call to_history("n2",n2,"mask_out3")
  call to_history("n3",n3,"mask_out3")
  call to_history("d1",1.0,"mask_out3"); call to_history("d2",1.0,"mask_out3")
  call to_history("d3",1.0,"mask_out3")
  call to_history("o1",0.,"mask_out3"); call to_history("o2",0.,"mask_out3")
  call to_history("o3",0.,"mask_out3")
  call to_history("esize",4,"mask_out3")
  call sep_write(mask_out3,"mask_out3")	





  call sep_close()
  call exit (0)
end program Create_picks














