program Calc_avr_dip  !
  !
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten,horizons,horizon_inc,dash,horizon_end
  integer                                ::horizon_strt,slice,thick,del_i2,counter
  real,    dimension (:,:),   allocatable ::image2d
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt,data_out2,dipx,dipy
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,xrand,first_point,second_point,totalx,totaly,x_squared,y_squared
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1)
  call from_param("horizons",horizons,0)
  call from_param("horizon_inc",horizon_inc,30)
  call from_param("horizon_strt",horizon_strt,1)
  call from_param("horizon_end",horizon_end,n1-1)
  call from_param("slice",slice,0)
  call from_param("dash",dash,0)
  call from_param("thick",thick,0)
  write(0,*) n1,n2,n3,ref_2,ref_3,horizon_inc
  write(0,*)'slice',slice

  subsam=1
  allocate (data_in(n1,n2,n3),dipx(n1,n2,n3),dipy(n1,n2,n3),data_out(n1,n2,n3),time_cube(n1,n2,n3),image2d(n1,n3))                              


  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("dipx", dipx,4*n1*n2*n3)
  call sreed("dipy", dipy,4*n1*n2*n3)
  call sreed("in", data_in,4*n1*n2*n3)
  ! call sreed("aux", time_cube,4*n1*n2*n3)

  data_out=0.
  image2d=0.

  totalx=0.
  totaly=0.
  x_squared=0.
  y_squared=0.
  counter=0
  do i1=1,20
     do i2=1,n2
        inner: do i3=1,n3
     !      if (dipx(i1,i2,i3)==0.) then
     !      else
              counter=counter+1
              totalx=totalx+(dipx(i1,i2,i3))
              totaly=totaly+(dipy(i1,i2,i3))
              x_squared=x_squared+dipx(i1,i2,i3)*dipx(i1,i2,i3)
              y_squared=y_squared+dipy(i1,i2,i3)*dipy(i1,i2,i3)

      !     end if
        end do inner
     end do
  end do
  write(0,*) 'totalx',totalx,'avr x',totalx/counter
  write(0,*) 'totaly',totaly,'avr y',totaly/counter
  write(0,*) 'counter',counter
write(0,*) 'variance x',(x_squared-(totalx*totalx/counter))/counter
write(0,*) 'variance y',(y_squared-(totaly*totaly/counter))/counter

!!$  call to_history ("n1",   n1)
!!$  call to_history ("n2",   n3)
!!$  call to_history ("n3",   1)    
!!$  !call to_history("d1",1)
!!$  call sep_write (image2d) 

!!$  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n2,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
!!$  call sep_write(outwt,"outwt")	






  call sep_close()
  call exit (0)
end program Calc_avr_dip














