program Identify_fault  !
  ! label faults integer values from a fault weight consisted of 0's and 1's where the 0's represent fault locations
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten,horizons,horizon_inc,dash,horizon_end,foundsecondpnt
  integer                                ::horizon_strt,slice,thick,del_i2
  real,    dimension (:,:),   allocatable ::image2d
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt,data_out2
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,xrand,first_point,second_point
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1)
  call from_param("horizons",horizons,0)
  call from_param("horizon_inc",horizon_inc,30)
  call from_param("horizon_strt",horizon_strt,1)
  call from_param("horizon_end",horizon_end,n1-1)
  call from_param("slice",slice,0)
  call from_param("dash",dash,0)
  call from_param("thick",thick,0)
  write(0,*) n1,n2,n3,ref_2,ref_3,horizon_inc
  write(0,*)'slice',slice

  subsam=1
  allocate (data_in (n1,n2,n3),data_out(n1,n2,n3),time_cube(n1,n2,n3),image2d(n1,n3))                              


  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1*n2*n3)

  data_out=0.
  image2d=0.
  do i1=1,n1
     do i2=1,n2
        inner: do i3=1,n3
           foundsecondpnt=0
           if (data_in(i1,i2,i3)==0..and.data_in(i1,i2-1,i3)==1.) then
              ! found a fault
              first_point=time_cube(i1,i2-1,i3)
              search: do del_i2=1,100
                 if (data_in(i1,i2+del_i2,i3)==0..and.data_in(i1,i2+del_i2+1,i3)==1.) then
                    ! got second point
                    second_point=time_cube(i1,i2+del_i2+1,i3)
                    foundsecondpnt=1
                    exit search
                 end if
              end do search
            !  if (first_point>0..and.second_point>0.)then
              if (foundsecondpnt==1) image2d(i1,i3)=second_point-first_point
         !end if
           end if
        end do inner
     end do
  end do



call to_history ("n1",   n1)
call to_history ("n2",   n3)
call to_history ("n3",   1)    
!call to_history("d1",1)
call sep_write (image2d) 

!!$  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n2,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
!!$  call sep_write(outwt,"outwt")	






call sep_close()
call exit (0)
end program














